zoukankan      html  css  js  c++  java
  • codeforces D

    D. Mishka and Interesting sum
    time limit per test
    3.5 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Little Mishka enjoys programming. Since her birthday has just passed, her friends decided to present her with array of non-negative integersa1, a2, ..., an of n elements!

    Mishka loved the array and she instantly decided to determine its beauty value, but she is too little and can't process large arrays. Right because of that she invited you to visit her and asked you to process m queries.

    Each query is processed in the following way:

    1. Two integers l and r (1 ≤ l ≤ r ≤ n) are specified — bounds of query segment.
    2. Integers, presented in array segment [l,  r] (in sequence of integers al, al + 1, ..., areven number of times, are written down.
    3. XOR-sum of written down integers is calculated, and this value is the answer for a query. Formally, if integers written down in point 2 are x1, x2, ..., xk, then Mishka wants to know the value , where  — operator of exclusive bitwise OR.

    Since only the little bears know the definition of array beauty, all you are to do is to answer each of queries presented.

    Input

    The first line of the input contains single integer n (1 ≤ n ≤ 1 000 000) — the number of elements in the array.

    The second line of the input contains n integers a1, a2, ..., an (1 ≤ ai ≤ 109) — array elements.

    The third line of the input contains single integer m (1 ≤ m ≤ 1 000 000) — the number of queries.

    Each of the next m lines describes corresponding query by a pair of integers l and r (1 ≤ l ≤ r ≤ n) — the bounds of query segment.

    Output

    Print m non-negative integers — the answers for the queries in the order they appear in the input.

    Examples
    input
    3
    3 7 8
    1
    1 3
    output
    0
    input
    7
    1 2 1 3 3 2 3
    5
    4 7
    4 5
    1 3
    1 7
    1 5
    output
    0
    3
    1
    3
    2
    Note

    In the second sample:

    There is no integers in the segment of the first query, presented even number of times in the segment — the answer is 0.

    In the second query there is only integer 3 is presented even number of times — the answer is 3.

    In the third query only integer 1 is written down — the answer is 1.

    In the fourth query all array elements are considered. Only 1 and 2 are presented there even number of times. The answer is .

    In the fifth query 1 and 3 are written down. The answer is .


    简述题意:给你一个长度为n的序列,以及t组询问,每组询问 l~r ,求区间内出现偶数次的数的亦或和。(n,t<=10^5)
    首先区间出现奇数次的数的亦或和就是区间亦或和,那么如果我们记录区间亦或和,再亦或 区间内出现过的数字的亦或和(比如 1 3 4 3)就是1^3^4^3=5,5^1^3^4=3,出现偶数次的是3。
    所以这就变成了一个无修改的输出区间出现过的数字的亦或和,我们这样考虑,先把询问离线排序,按照右端点排序后,用线段树维护区间亦或和,则比如我一个数字在3,7,8位置都出现过,那我记录他上一次在哪出现,把上一个位置的数字改为0,再在新位置放上这个数,然后线段树query即可。
    即if(lst[find(a[i])]) update(lst[find(a[i])] , a[i]); update(i.a[i]); printf("%d ",query(l,r));

    #include <stdio.h>
    #include <iostream>
    #include <memory.h>
    #include <algorithm>
    using namespace std;
     
    #define getch() getchar()
    inline int F() { register int aa , bb , ch;
        while(ch = getch() , (ch<'0'||ch>'9') && ch != '-'); ch == '-' ? aa=bb=0 : (aa=ch-'0',bb=1);
        while(ch = getch() , ch>='0'&&ch<='9') aa = aa*10 + ch-'0'; return bb ? aa : -aa;
    }
     
    const int Maxn = 1000010;
    const int Maxt = 8000020;
    struct node {
        int l , r , id;
    } q[Maxn];
    int n , m , s[Maxn] , a[Maxn] , tmp , b[Maxn] , bcnt , ll[Maxt] , rr[Maxt] , tree[Maxt] , lst[Maxn] , ANS[Maxn];
     
    void unique() {
        bcnt = 1;
        for(int i=2; i<=n; ++i)
            if(b[i] != b[bcnt]) b[++bcnt] = b[i];
    }
     
    int search(int x) {
        int l = 1 , r = bcnt , ans = 0;
        while(l <= r) {
            int mid = (l + r) >> 1;
            if(b[mid] >= x) r = mid - 1 , ans = mid;
            else l = mid + 1;
        }return ans;
    }
     
    void Build(int x , int l , int r) {
        ll[x] = l; rr[x] = r;
        tree[x] = 0;
        if(l == r) return;
        int mid = (l + r) >> 1;
        Build(x<<1 , l ,mid);
        Build(x<<1|1 , mid+1 , r);
    }
     
    void update(int x , int k , int kk) {
        tree[x] ^= kk;
        if(ll[x] == rr[x]) return ;
        int mid = (ll[x] + rr[x]) >> 1;
        if(mid >= k) update(x<<1 , k , kk);
        else update(x<<1|1 , k , kk);
        tree[x] = tree[x<<1] ^ tree[x<<1|1];
    }
     
    int query(int x , int l , int r) {
        l = max(ll[x] , l) ; r = min(rr[x] , r);
        if(l > r) return 0;
        if(l == ll[x] && r == rr[x]) return tree[x];
        return query(x<<1 , l , r) ^ query(x<<1|1 , l , r);
    }
     
    inline bool cmp (node a , node b) { return a.r < b.r; }
     
    int main() {
        n = F();
        for(int i=1; i<=n; ++i) {
            a[i] = b[i] = F();
            s[i] = s[i-1] ^ a[i];
    //      printf("s[%d] = %d
    ",i , s[i] );
        }
        Build(1,1,n);
        std::sort(b+1,b+n+1);
        unique();
    //  for(int i=1; i<=bcnt; ++i) printf("%d ",b[i] ); puts("");
        m = F();
        for(int i=1; i<=m; ++i) {
            q[i].l = F();
            q[i].r = F();
            q[i].id = i;
        }
        int j = 1;
        std::sort(q+1,q+m+1,cmp);
    //  for(int i=1; i<=m; ++i)  { printf("Qid:%d : %d %d
    ", q[i].id , q[i].l , q[i].r); }
        for(int i=1; i<=m; ++i) {
            while(j <= q[i].r) {
                int tmp = search(a[j]);
    //          printf("aj = %d tmp = %d
    ", a[j] , tmp);
                if(lst[tmp]) {
                    update(1,lst[tmp],a[j]);
    //              printf("lst[%d] = %d
    ",tmp , lst[tmp] );
                }
                update(1,j,a[j]);
                lst[tmp] = j;
                ++j;
            }
            ANS[q[i].id] = query(1 , q[i].l , q[i].r) ^ s[q[i].r] ^ s[q[i].l-1];
    //      for(int i=1; i<=n; ++i) printf("%d ", query(1,i,i)); puts("");
    //      printf("QL : %d , Qr : %d , Qans = %d
    " ,q[i].l , q[i].r , ANS[q[i].id]);
        }
        for(int i=1; i<=m; ++i) printf("%d
    ", ANS[i]);
        return 0;
    }
    View Code
  • 相关阅读:
    利用python求非线性方程
    迪士尼穷游攻略
    爬虫八之爬取京东商品信息
    爬虫七之分析Ajax请求并爬取今日头条
    爬虫五之Selenium
    爬虫4之pyquery
    前端传入 SQL 语句 到后端执行
    手写分页处理
    集合(Map,List)分组:多属性进行分组
    java 枚举类非常好的运用实例
  • 原文地址:https://www.cnblogs.com/gc812/p/5869551.html
Copyright © 2011-2022 走看看